#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <unistd.h>
#include <afblib/hostport.h>
#include "tf-session.h"

#define PORT 17017

int main(int argc, char** argv) {
   char* cmdname = *argv++;  --argc;
   if (argc != 1) {
      fprintf(stderr, "Usage: %s hostport\n", cmdname); exit(1);
   }
   hostport hp;
   if (!parse_hostport(*argv, &hp, PORT)) {
      fprintf(stderr, "%s: invalid hostport\n", cmdname); exit(1);
   }

   int sfd = socket(hp.domain, SOCK_STREAM, hp.protocol);
   int optval = 1;
   if (sfd < 0 ||
        setsockopt(sfd, SOL_SOCKET, SO_REUSEADDR,
                   &optval, sizeof optval) < 0 ||
        bind(sfd, (struct sockaddr *) &hp.addr, hp.namelen) < 0 ||
        listen(sfd, SOMAXCONN) < 0) {
      perror("socket"); exit(1);
   }
   int fd;
   while ((fd = accept(sfd, 0, 0)) >= 0) {
      tf_session(fd);
      close(fd);
   }
}
